#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <gc.h>
#include <assert.h>
#include <stdlib.h>

#define malloc YOU_SUCK
#define free YOU_SUCK
#define realloc YOU_SUCK
#define strdup YOU_SUCK

int length;
char *input;
char colors[]="rgbcmykwZ";

void *mkmask(int x)
{
  void *ret;
  ret=GC_malloc(x);
  assert(ret);
  return ret;
}

#define GC_malloc(x) mkmask(x)

typedef struct _mylist mylist;
struct _mylist
{
  char *data;
  mylist *next;
};

void readall()
{
  mylist *ret,*foo;
  int cursor,x;
  cursor=0;
  length=0;
  foo=ret=GC_malloc(sizeof(mylist));
  foo->data=GC_malloc_atomic(256);
  foo->next=0;
  while(!feof(stdin))
    {
      foo->data[cursor]=getchar();
      if(feof(stdin))
	break;
      cursor++;
      length++;
      if(cursor==256)
	{
	  foo->next=GC_malloc(sizeof(mylist));
	  foo=foo->next;
	  foo->data=GC_malloc_atomic(256);
	  cursor=0;
	  foo->next=0;
	}
    }
  foo=ret;
  input=GC_malloc_atomic(length+1);
  input[length]=0;
  if(length>0)
    {
      x=0;
      while(foo->next)
	{
	  memcpy(input+x,foo->data,256);
	  x+=256;
	  foo=foo->next;
	}
      memcpy(input+x,foo->data,cursor);
    }
}

char *zstrdup(char *foo)
{
  char *ret;
  if(foo==0) return 0;
  ret=GC_malloc_atomic(strlen(foo)+1);
  strcpy(ret,foo);
  return ret;
}

typedef struct _atom atom;
struct _atom
{
  int state;
  char *data;
  int s;
  atom *next;
};

atom atoms,*atom_last;
int natoms;
atom **at;

#define flag_b(b) ((b)?1:0)
#define flag_i(i) ((i)?2:0)
#define flag_tt(tt) ((tt)?4:0)
#define make_ems(ems) ((ems)*8)
#define state_ems(em,s) ((s)?make_ems(2):((em)?make_ems(1):make_ems(0)))
#define state_u(u) ((u)*24)
// sizes are 0-9 or 10 for initial size
#define state_size(s) ((s)*96)
// colors are 0-7 or 8 for initial color
#define state_color(c)  ((c)*1056)
// There are 9504 possible states starting at 0 through 9503

#define get_b(x) ((x)%2)
#define get_i(x) (((x)/2)%2)
#define get_tt(x) (((x)/4)%2)
#define get_ems(x) (((x)/8)%3)
#define get_u(x) (((x)/24)%4)
#define get_size(x) (((x)/96)%11)
#define get_color(x) (((x)/1056)%9)

#define clear_ems(x) ((x)-make_ems(get_ems(x)))
#define clear_u(x) ((x)-state_u(get_u(x)))
#define clear_size(x) ((x)-state_size(get_size(x)))
#define clear_color(x) ((x)-state_color(get_color(x)))

typedef struct _xx xx;
struct _xx
{
  int type;
  xx *a,*b;
  int cost;
};


char *strcon(char *a, char *b)
{
  char *ret;
  if(a==0 || b==0) return 0;
  ret=GC_malloc_atomic(strlen(a)+strlen(b)+1);
  strcpy(ret,a);
  strcpy(ret+strlen(a),b);
  ret[strlen(a)+strlen(b)]=0;
  return ret;
}

char *strcon3(char *a, char *b, char *c)
{ return strcon(a,strcon(b,c)); }


int kost(xx *x)
{
  if(x==0) return length+1;
  return x->cost;
}

xx *cons(xx *a, xx *b)
{
  xx *ret;
  ret=GC_malloc(sizeof(xx));
  ret->type=0;
  ret->a=a; ret->b=b;
  ret->cost=kost(a)+kost(b);
  return ret;
}

xx *tok(int i)
{
  xx *ret;
  ret=GC_malloc(sizeof(xx));
  ret->type=1;
  ret->a=(xx *)at[i]->data;
  ret->cost=at[i]->s;
  return ret;
}

xx *tag(char *tag, xx *a)
{
  xx *ret;
  ret=GC_malloc(sizeof(xx));
  ret->type=2;
  ret->a=(xx *)zstrdup(tag);
  ret->b=a;
  ret->cost=strlen(tag)*2+5+kost(a);
  return ret;
}

typedef struct
{
  int n;
  char **tags;
} tagstack;


int tagdepth(xx *a)
{
  if(a->type!=2) return 0;
  return tagdepth(a->b)+1;
}
tagstack *gettagstack(xx *a)
{
  int i,j,k;
  char **tags;
  tagstack *ret;
  k=tagdepth(a);
  ret=GC_malloc(sizeof(tagstack));
  if(k==0)
    {
      ret->tags=0;
      ret->n=0;
      return ret;
    }
  tags=GC_malloc(sizeof(char *)*(k+1));
  if(!strcmp((char *)a->a,"PL"))
    {
      tags[0]=(char *)a->a;
      i=1;
    }
  else
    {
      for(i=0;i<k;i++)
	{
	  assert(a && a->type==2);
	  /*
	  if(!strcmp((char *)a->a,"S") ||
	     !strcmp((char *)a->a,"TT") ||
	     !strcmp((char *)a->a,"PL") ||
	     (((char *)a->a)[0]>='0' && ((char *)a->a)[0]<='9') ||
	     (strchr(colors,((char *)a->a)[0])))
	  */
	  if(!strcmp((char *)a->a,"PL"))
	    break;
	  tags[i]=(char *)a->a;
	  a=a->b;
	}
    }
  tags[i]="";
  ret=GC_malloc(sizeof(tagstack));
  ret->tags=tags;
  ret->n=i;
  return ret;
}

#define R(x,y,z) x[(y)+(z)*(m+1)]

void longest(char *a[], char *b[],
	     int m, int n,
	     int i, int j,
	     int *lengths, int *choice)
{
  if(R(lengths,i,j)>=0) return;
  longest(a,b,m,n,i+1,j+1,lengths,choice);
  longest(a,b,m,n,i,j+1,lengths,choice);
  longest(a,b,m,n,i+1,j,lengths,choice);
  if(R(lengths,i+1,j)>R(lengths,i,j+1))
    {
      R(lengths,i,j)=R(lengths,i+1,j);
      R(choice,i,j)=0;
    }
  else
    {
      R(lengths,i,j)=R(lengths,i,j+1);
      R(choice,i,j)=1;
    }
  if((strcmp(a[i],b[j])==0) && ((R(lengths,i+1,j+1)+1)>R(lengths,i,j)))
    {
      R(lengths,i,j)=1+R(lengths,i+1,j+1);
      R(choice,i,j)=2;
    }
}

tagstack *lcs(tagstack *a, tagstack *b)
{
  int *lengths;
  int *choice;
  int i,j,m,k;
  tagstack *ret;

  m=a->n;
  lengths=GC_malloc_atomic(sizeof(int)*(a->n+1)*(b->n+1));
  choice=GC_malloc_atomic(sizeof(int)*(a->n+1)*(b->n+1));
  for(i=0;i<m;i++)
    {
      for(j=0;j<b->n;j++)
	{
	  R(lengths,i,j)=-1;
	}
    }
  for(i=0;i<m;i++)
    R(lengths,i,b->n)=0;
  for(i=0;i<b->n;i++)
    R(lengths,a->n,i)=0;
  R(lengths,a->n,b->n)=0;
  longest(a->tags,b->tags,a->n,b->n,0,0,lengths,choice);
  i=j=0;
  ret=GC_malloc(sizeof(tagstack));
  ret->tags=GC_malloc(sizeof(char *)*(R(lengths,0,0)+1));
  ret->n=R(lengths,0,0);
  k=0;
  while(k<R(lengths,0,0))
    {
      switch(R(choice,i,j))
	{
	case 0: i++; break;
	case 1: j++; break;
	case 2: ret->tags[k++]=a->tags[i]; i++; j++; break;
	default: abort();
	}
    }
  ret->tags[ret->n]="";
  return ret;
}

void prstack(tagstack *x)
{
  int i;
  printf("tagstack: (%i)",x->n);
  for(i=0;i<x->n;i++)
    printf(" %s",x->tags[i]);
  puts("");
}

xx *optcons(xx *a, xx *b)
{
  if(a==0 || b==0) return 0;
  if(a->type==2 && b->type==2 &&
     strcmp((char *)a->a,(char *)b->a)==0)
    return tag((char *)a->a,optcons(a->b,b->b));
  return cons(a,b);
}

tagstack *newtags(int i)
{
  tagstack *ret;
  ret=GC_malloc(sizeof(tagstack));
  ret->n=i;
  ret->tags=GC_malloc(sizeof(char *)*i);
  return ret;
}

xx *stripntags(xx *a, int n)
{
  if(n==0) return a;
  assert(a && a->type==2);
  return stripntags(a->b,n-1);
}

xx *makentags(xx *a, int i, tagstack *t)
{
  if(i==t->n) return a;
  assert(i>=0 && i<t->n);
  return tag(t->tags[i],makentags(a,i+1,t));
}

char *actual_color;
char *actual_size;

int mycmp(char *a, char *b)
{
  if(!strcmp(a,actual_color) || !strcmp(a,actual_size))
    {
      if(strcmp(b,actual_color))
	return 1;
      return -1;
    }
  if(!strcmp(b,actual_color) || !strcmp(b,actual_size))
    {
      if(strcmp(a,actual_color))
	return -1;
      return 1;
    }
  return strcmp(a,b);
}

void sorttags(tagstack *x)
{
  int i;
  actual_size="";
  actual_color="";
  for(i=0;i<x->n;i++)
    if(x->tags[i][0]>='0' && x->tags[i][0]<='9')
      actual_size=x->tags[i];
    else if(strchr(colors,x->tags[i][0]))
      actual_color=x->tags[i];
  qsort(x->tags,x->n,sizeof(char *),mycmp);
}

xx *faccons(xx *a, xx *b)
{
  int i,j,k;
  tagstack *x, *y,*z,*X,*Y;
  if(a==0 || b==0) return 0;
  x=gettagstack(a);
  y=gettagstack(b);
  if(x->n==0 || y->n==0) return cons(a,b);

  //  sorttags(x);
  //  sorttags(y);

  z=lcs(x,y);

  X=newtags(x->n-z->n);
  Y=newtags(y->n-z->n);
  j=0; k=0;
  for(i=0;i<x->n;i++)
    if(strcmp(z->tags[k],x->tags[i]))
      X->tags[j++]=x->tags[i];
    else
      k++;
  j=0; k=0;
  for(i=0;i<y->n;i++)
    if(strcmp(z->tags[k],y->tags[i]))
      Y->tags[j++]=y->tags[i];
    else
      k++;

  if(z->n==0) return cons(a,b);
  a=stripntags(a,x->n);
  b=stripntags(b,y->n);
  return makentags(faccons(makentags(a,0,X),makentags(b,0,Y)),0,z);
}

void _xx2str(char *s, xx *x)
{
  switch(x->type)
    {
    case 0:
      _xx2str(s,x->a);
      _xx2str(s+x->a->cost,x->b);
      break;
    case 1:
      strcpy(s,((char *)x->a));
      break;
    case 2:
      sprintf(s,"<%s>",(char *)x->a);
      _xx2str(s+2+strlen((char *)x->a),x->b);
      sprintf(s+2+strlen((char *)x->a)+kost(x->b),"</%s>",(char *)x->a);
      break;
    default:
      abort();
    }
}

char *xx2str(xx *x)
{
  char *ret;
  if(kost(x)>length) return "<infinite string>";
  ret=GC_malloc_atomic(kost(x)+1);
  _xx2str(ret,x);
  return ret;
}

void _prxx(xx *x)
{
  switch(x->type)
    {
    case 0:
      printf("(");
      _prxx(x->a);
      printf(",");
      _prxx(x->b);
      printf(")");
      break;
    case 1:
      printf((char *)x->a);
      break;
    case 2:
      printf("<%s>",(char *)x->a);
      _prxx(x->b);
      printf("</%s>",(char *)x->a);
      break;
    default:
      abort();
    }
}

void prxx(xx *x)
{
  _prxx(x);
  puts("");
}

int cost(char *a)
{
  if(a==0) return length;
  return strlen(a);
}

char *state_string(int state)
{
  char *ret;
  char fook[256];
  sprintf(fook,"b=%i i=%i tt=%i ems=%i u=%i size=%i color=%i",
	  get_b(state),get_i(state),get_tt(state),get_ems(state),
	  get_u(state),get_size(state),get_color(state));
  ret=GC_malloc_atomic(strlen(fook)+1);
  strcpy(ret,fook);
  return ret;
}

#define initial_state (state_color(8)+state_size(10))

#define num_states 9504

enum colors {
  red=0,
  green,
  blue,
  cyan,
  magenta,
  yellow,
  black,
  white,
  initial_color
};

int cursor;
char temp_tok[10];
int prev_is_ws;
char *temp_buf,*temp_buf2;
int best_length;
int *cum_length;

void dump(int caca, int state)
{
  if(caca>0)
    {
      atom_last->next=GC_malloc(sizeof(atom));
      atom_last=atom_last->next;
      atom_last->data=GC_malloc(caca+1);
      memcpy(atom_last->data,temp_buf,caca);
      atom_last->data[caca]=0;
      atom_last->s=caca;
      atom_last->next=0;
      atom_last->state=state;
      natoms++;
    }
}

void parse(int b, int em, int i, int s, int tt, int u,
	   int size, int color)
{
  int foo,bar,zoo,caca;
  if(u>3) u=3;
  caca=0;
  while(1)
    {
      assert(cursor<=length);
      if(cursor == length)
	{
	  dump(caca,flag_b(b)+flag_i(i)+flag_tt(tt)+
	       state_ems(em,s)+state_u(u)+state_size(size)+
	       state_color(color));
	  return;
	}
      if(input[cursor]=='<')
	{
	  dump(caca,flag_b(b)+flag_i(i)+flag_tt(tt)+
	       state_ems(em,s)+state_u(u)+state_size(size)+
	       state_color(color));
	  caca=0;

	  foo=cursor+1;
	  while(input[foo]!='>') foo++;
	  bar=cursor+1;
	  cursor=foo+1;

	  if(input[bar]=='/') return;

	  for(zoo=bar;zoo<foo;zoo++)
	    temp_tok[zoo-bar]=input[zoo];
	  temp_tok[zoo-bar]=0;
	  if(!strcmp(temp_tok,"B"))
	    parse(1,em,i,s,tt,u,size,color);
	  else if(!strcmp(temp_tok,"EM"))
	    parse(b,1-em,i,s,tt,u,size,color);
	  else if(!strcmp(temp_tok,"I"))
	    parse(b,em,1,s,tt,u,size,color);
	  else if(!strcmp(temp_tok,"PL"))
	    parse(0,0,0,0,0,0,size,color);
	  else if(!strcmp(temp_tok,"S"))
	    parse(b,0,i,1,tt,u,size,color);
	  else if(!strcmp(temp_tok,"TT"))
	    parse(b,em,i,s,1,u,size,color);
	  else if(!strcmp(temp_tok,"U"))
	    parse(b,em,i,s,tt,u+1,size,color);
	  else if(isdigit(temp_tok[0]) && temp_tok[1]==0)
	    parse(b,em,i,s,tt,u,temp_tok[0]-'0',color);
	  else if(!strcmp(temp_tok,"r"))
	    parse(b,em,i,s,tt,u,size,red);
	  else if(!strcmp(temp_tok,"g"))
	    parse(b,em,i,s,tt,u,size,green);
	  else if(!strcmp(temp_tok,"b"))
	    parse(b,em,i,s,tt,u,size,blue);
	  else if(!strcmp(temp_tok,"c"))
	    parse(b,em,i,s,tt,u,size,cyan);
	  else if(!strcmp(temp_tok,"m"))
	    parse(b,em,i,s,tt,u,size,magenta);
	  else if(!strcmp(temp_tok,"y"))
	    parse(b,em,i,s,tt,u,size,yellow);
	  else if(!strcmp(temp_tok,"k"))
	    parse(b,em,i,s,tt,u,size,black);
	  else if(!strcmp(temp_tok,"w"))
	    parse(b,em,i,s,tt,u,size,white);
	  else
	    {
	      printf("Unrecognized token %s at position %i in input",
		     temp_tok,bar);
	      abort();
	    }
	}
      else
	{
	  if(input[cursor]==' ' || input[cursor]=='\n'
	     || input[cursor]=='\t' || input[cursor]=='\r')
	    {
	      if(u==0) bar=white;
	      else bar=color;
	      foo=flag_tt(tt)+state_u(u)+state_size(size)+state_color(bar);
	      if(tt)
		{
		  temp_buf[caca++]=input[cursor];
		}
	      else if(prev_is_ws!=foo)
		{
		  temp_buf[caca++]=' ';
		}
	      prev_is_ws=foo;
	    }
	  else
	    {
	      prev_is_ws=-1;
	      temp_buf[caca++]=input[cursor];
	    }
	  cursor++;
	}
    }
  temp_buf=temp_buf2=0;
}

int state_change(int a, int b)
{
  int ret;
  ret=0;
  if(get_size(a)!=get_size(b)) ret+=3;
  if(get_color(a)!=get_color(b)) ret+=3;
  if((get_i(a)!=get_i(b)) ||
     (get_ems(a)!=get_ems(b)) ||
     (get_tt(a)!=get_tt(b)) ||
     (get_b(a)!=get_b(b)) ||
     (get_u(a)!=get_u(b))) ret+=3;
  return ret;
}

void parse_main(void)
{
  int i,j;
  int prev_state;
  atom *foo;
  temp_buf=GC_malloc_atomic(length*2); //FIXME
  temp_buf2=GC_malloc_atomic(length*2); //FIXME
  cursor=0;
  prev_is_ws=-1;
  atoms.next=0;
  atom_last=&atoms;
  natoms=0;
  parse(0,0,0,0,0,0,10,initial_color);
  at=GC_malloc(sizeof(atom *)*(natoms+1));
  cum_length=GC_malloc_atomic(sizeof(int)*(natoms+1));
  cum_length[0]=0;
  foo=atoms.next;
  i=0;
  prev_state=initial_state;
  while(foo)
    {
      at[i]=foo;
      foo=foo->next;
      cum_length[i+1]=cum_length[i]+at[i]->s+
	state_change(prev_state,at[i]->state);
      prev_state=at[i]->state;
      i++;
    }
  assert(i==natoms);
  i=0;
  for(j=1;j<natoms;j++)
    {
      if(at[i]->state==at[j]->state)
	{
	  at[i]->s+=at[j]->s;
	  at[i]->data=strcon(at[i]->data,at[j]->data);
	}
      else
	{
	  i++;
	  at[i]=at[j];
	}
    }
  natoms=i+1;
  if(natoms)
    cum_length[natoms-1]+=state_change(at[natoms-1]->state,initial_state);
}

void printall(void)
{
  int i;
  for(i=0;i<natoms;i++)
    {
      printf("%i %s\n",at[i]->state,at[i]->data);
    }
}

int could_b(int a, int b, int v)
{
  int i;
  if(v) return 0;
  for(i=a;i<b;i++)
    if(get_b(at[i]->state)!=v) return 1;
  return 0;
}
int could_i(int a, int b, int v)
{
  int i;
  if(v) return 0;
  for(i=a;i<b;i++)
    if(get_i(at[i]->state)!=v) return 1;
  return 0;
}
int could_tt(int a, int b, int v)
{
  int i;
  if(v) return 0;
  for(i=a;i<b;i++)
    if(get_tt(at[i]->state)!=v) return 1;
  return 0;
}
int could_u(int a, int b, int v)
{
  int i;
  if(v==3) return 0;
  for(i=a;i<b;i++)
    if(get_u(at[i]->state)>v) return 1;
  return 0;
}
int could_em(int a, int b, int v)
{
  int i;
  if(v==2) return 0;
  for(i=a;i<b;i++)
    if(get_ems(at[i]->state)!=v &&
       get_ems(at[i]->state)!=2) return 1;
  return 0;
}
int could_s(int a, int b, int v)
{
  int i;
  if(v==2) return 0;
  for(i=a;i<b;i++)
    if(get_ems(at[i]->state)==2) return 1;
  return 0;
}
int could_size(int a, int b, int v)
{
  int i;
  for(i=a;i<b;i++)
    if(get_size(at[i]->state)==v) return 1;
  return 0;
}
int could_color(int a, int b, int v)
{
  int i;
  for(i=a;i<b;i++)
    if(get_color(at[i]->state)==v) return 1;
  return 0;
}
int could_pl(int a, int b, int v)
{
  int i;
  for(i=a;i<b;i++)
    if((get_b(at[i]->state)==0 && get_b(v)==1) ||
       (get_i(at[i]->state)==0 && get_i(v)==1) ||
       (get_ems(at[i]->state)<get_ems(v)) ||
       (get_tt(at[i]->state)==0 && get_tt(v)==1) ||
       (get_u(at[i]->state)<get_u(v))) return 1;
  return 0;
}

xx *godown(int a, int state)
{
  char foo[2];
  if((get_size(state)<10 && get_size(at[a]->state)==10) ||
     (get_color(state)<initial_color &&
      get_color(at[a]->state)==initial_color))
    return 0;
  if((get_b(state) && !get_b(at[a]->state)) ||
     (get_i(state) && !get_i(at[a]->state)) ||
     (get_tt(state) && !get_tt(at[a]->state)) ||
     (get_u(state)>get_u(at[a]->state)) ||
     (get_ems(state)==2 && get_ems(at[a]->state)<2))
    return tag("PL",
	       godown(a,state_size(get_size(state))+
		      state_color(get_color(state))));
  if(get_b(state)!=get_b(at[a]->state))
    return tag("B",godown(a,state+flag_b(1)));
  if(get_i(state)!=get_i(at[a]->state))
    return tag("I",godown(a,state+flag_i(1)));
  if(get_tt(state)!=get_tt(at[a]->state))
    return tag("TT",godown(a,state+flag_tt(1)));
  if(get_ems(state)!=get_ems(at[a]->state))
    {
      if(get_ems(at[a]->state)==2)
	return tag("S",godown(a,clear_ems(state)+state_ems(0,1)));
      return tag("EM",
		 godown(a,clear_ems(state)+state_ems(1-get_ems(state),0)));
    }
  if(get_u(state)!=get_u(at[a]->state))
    return tag("U",godown(a,clear_u(state)+state_u(get_u(state)+1)));
  if(get_size(state)!=get_size(at[a]->state))
    {
      sprintf(foo,"%i",get_size(at[a]->state));
      return tag(foo,godown(a,clear_size(state)+
			    state_size(get_size(at[a]->state))));
    }
  if(get_color(state)!=get_color(at[a]->state))
    {
      sprintf(foo,"%c",colors[get_color(at[a]->state)]);
      return tag(foo,godown(a,clear_color(state)+
			    state_color(get_color(at[a]->state))));
    }
  return tok(a);
}

xx *split(int a, int b, int alpha, int state);
xx *attempt_b(int a, int b, int alpha, int state)
{
  if(cum_length[b]-cum_length[a]+7>=alpha) return 0;
  if(could_b(a,b,get_b(state)))
    return tag("B",split(a,b,alpha-7,state+flag_b(1)));
  return 0;
}

xx *attempt_i(int a, int b, int alpha, int state)
{
  if(cum_length[b]-cum_length[a]+7>=alpha) return 0;
  if(could_i(a,b,get_i(state)))
    return tag("I",split(a,b,alpha-7,state+flag_i(1)));
  return 0;
}

xx *attempt_tt(int a, int b, int alpha, int state)
{
  if(cum_length[b]-cum_length[a]+9>=alpha) return 0;
  if(could_tt(a,b,get_tt(state)))
    return tag("TT",split(a,b,alpha-9,state+flag_tt(1)));
  return 0;
}

xx *attempt_em(int a, int b, int alpha, int state)
{
  if(cum_length[b]-cum_length[a]+9>=alpha) return 0;
  if(could_em(a,b,get_ems(state)))
    return tag("EM",split(a,b,alpha-9,state+
			  state_ems(1-get_ems(state),0)));
  return 0;
}

xx *attempt_s(int a, int b, int alpha, int state)
{
  if(cum_length[b]-cum_length[a]+7>=alpha) return 0;
  if(could_s(a,b,get_ems(state)))
    return tag("S",split(a,b,alpha-7,
			 clear_ems(state)+state_ems(0,1)));
  return 0;
}

xx *attempt_size(int a, int b, int alpha, int state, int size)
{
  char foo[5];
  if(cum_length[b]-cum_length[a]+7>=alpha) return 0;
  if(get_size(state)!=size &&
     could_size(a,b,size))
    {
      sprintf(foo,"%i",size);
      return tag(foo,split(a,b,alpha-7,clear_size(state)+state_size(size)));
    }
  return 0;
}

xx *attempt_color(int a, int b, int alpha, int state, int color)
{
  char foo[5];
  if(cum_length[b]-cum_length[a]+7>=alpha) return 0;
  if(get_color(state)!=color &&
     could_color(a,b,color))
    {
      sprintf(foo,"%c",colors[color]);
      return tag(foo,split(a,b,alpha-7,clear_color(state)+
			   state_color(color)));
    }
  return 0;
}

#define SUB() if(kost(foo)<alpha) { ret=foo; alpha=kost(foo); }
xx *split(int a, int b, int alpha, int state)
{
  int i;
  xx *ret,*foo,*bar;
  if(cum_length[b]-cum_length[a]>=alpha) return 0;
  ret=0;
  foo=godown(a,state);
  for(i=a+1;i<b;i++)
    {
      foo=faccons(foo,godown(i,state));
    }
  SUB();
  foo=attempt_b(a,b,alpha,state);
  SUB();
  foo=attempt_i(a,b,alpha,state);
  SUB();
  foo=attempt_tt(a,b,alpha,state);
  SUB();
  foo=attempt_em(a,b,alpha,state);
  SUB();
  foo=attempt_s(a,b,alpha,state);
  SUB();
  for(i=a+1;i<b;i++)
    {
      foo=split(a,i,alpha-(cum_length[b]-cum_length[i]),state);
      bar=split(i,b,alpha-kost(foo),state);
      foo=faccons(foo,bar);
      SUB();
    }
  //printf("split %i %i %i %s `%s'\n",a,b,alpha,state_string(state),ret);
  return ret;
}

char *fook1[]=
{ "1", "2", "3", "4", "5", "6", ""};
char *book1[]=
{ "1", "a", "5", "3", "4", "6", "5", "6", "" };
tagstack fook={ 6, fook1 };

tagstack book={ 8, book1 };


int get_chump(int natoms)
{
  return 4;
}

xx *split0(int a, int b, int alpha, int state)
{
  if(b-a==1)
    return godown(a,state);
  return split(a,b,alpha,state);
}

void chomp(int CHUMP)
{
  int i,j,k,l;
  xx *foo,*bar;
  xx **caca;
  if(natoms==0) return;
  caca=GC_malloc(sizeof(xx *)*natoms);
  for(i=0,j=0;i+CHUMP<natoms;i+=CHUMP,j++)
    caca[j]=split0(i,i+CHUMP,10000000,initial_state);
  caca[j]=split0(i,natoms,10000000,initial_state);
  j++;
  for(k=1;k<j;k*=2)
    {
      for(l=0;l<j;l+=2*k)
	{
	  if(l+k<j)
	    caca[l]=faccons(caca[l],caca[l+k]);
	}
    }
  printf(xx2str(caca[0]));
}

void puke(char *name, int a, int b)
{
  int i;
  FILE *f;
  f=fopen(name,"w");
  assert(f);
  i=b-a;
  fwrite(&i,sizeof(int),1,f);
  for(i=a;i<b;i++)
    {
      fwrite(at[i],sizeof(atom),1,f);
      fwrite(at[i]->data,at[i]->s,1,f);
    }
  fclose(f);
}

void felch(char *name)
{
  int i,prev_state;
  FILE *f;

  length=10000000;
  f=fopen(name,"r");
  assert(f);
  fread(&natoms,sizeof(int),1,f);
  at=GC_malloc(sizeof(atom *)*natoms);
  for(i=0;i<natoms;i++)
    {
      at[i]=GC_malloc(sizeof(atom));
      fread(at[i],sizeof(atom),1,f);
      at[i]->data=GC_malloc(at[i]->s+1);
      fread(at[i]->data,at[i]->s,1,f);
      at[i]->data[at[i]->s]=0;
    }
  cum_length=GC_malloc_atomic(sizeof(int)*(natoms+1));
  cum_length[0]=0;
  prev_state=initial_state;
  for(i=0;i<natoms;i++)
    {
      cum_length[i+1]=cum_length[i]+at[i]->s+
	state_change(prev_state,at[i]->state);
    }
  if(natoms)
    cum_length[natoms-1]+=state_change(at[natoms-1]->state,initial_state);
  fclose(f);
}

#define ZBLK 1000
int wrapper(int tlimit)
{
  int i,j;
  char s[1024];
  int chomper;
  FILE *f;
  struct timeval tv;
  double tt,t0,t1,a,b;
  readall();
  parse_main();
  f=fopen("myfile","w");
  assert(f);
  fclose(f);
  if(natoms==0) return 0;
  if(natoms>10000) chomper=3;
  else if(natoms>1000) chomper=4;
  else if(natoms>250) chomper=5;
  else chomper=6;
  gettimeofday(&tv,0);
  tt=tv.tv_sec+tv.tv_usec/1000000.0;
  for(i=0;i+ZBLK<natoms;i+=ZBLK)
    {
      puke("puke",i,i+ZBLK);
      sprintf(s,"./runme felch %i >> myfile",chomper);
      gettimeofday(&tv,0);
      t0=tv.tv_sec+tv.tv_usec/1000000.0;
      system(s);
      gettimeofday(&tv,0);
      t1=tv.tv_sec+tv.tv_usec/1000000.0;
      j=natoms-i-ZBLK;
      a=(t1-t0)/((double)ZBLK);
      b=a*j+t1-tt;
      if(b>tlimit+30) chomper-=2;
      if(b>tlimit) chomper--;
      if(b<tlimit/4.0) chomper++;
      if(chomper<1) chomper=1;
      if(chomper>6) chomper=6;
    }
  puke("puke",i,natoms);
  sprintf(s,"./runme felch %i >> myfile",chomper);
  system(s);
  f=fopen("myfile","r");
  fseek(f,0,SEEK_END);
  if(ftell(f)<length)
    {
      system("cat myfile");
    }
  else
    {
      printf(input);
    }
}

int sodomite(int chomper)
{
  int i,j;
  felch("puke");
  i=0;
  if(could_b(0,natoms,0)) i++;
  if(could_i(0,natoms,0)) i++;
  if(could_tt(0,natoms,0)) i++;
  if(could_u(0,natoms,0)) i++;
  if(could_em(0,natoms,0)) i++;
  if(could_s(0,natoms,0)) i++;
  for(j=0;j<10;j++)
    if(could_size(0,natoms,j)) i++;
  for(j=0;j<8;j++)
    if(could_color(0,natoms,j)) i++;
  if(i<4) chomper++;
  if(i<8) chomper++;
  //  fprintf(stderr,"chomper %i\n",chomper);
  chomp(chomper);
}

#if 0
int main(int argc, char *argv[])
{
  int i,j;
  xx *foo,*bar;
  xx **caca;
  int CHUMP;

  //  prstack(&fook);
  //  prstack(&book);
  //  prstack(lcs(&fook,&book));

  GC_enable_incremental();
  readall();
  //  printf("`%s'\n",input);
  parse_main();
  if(natoms==0) return 0;
  //  printall();
  if(argc!=2)
    CHUMP=get_chump(natoms);
  else
    CHUMP=atoi(argv[1]);
  fprintf(stderr,"natoms=%i\n",natoms);
  chomp(CHUMP);
#if 0
  i=0;
  j=0;
  if(CHUMP<natoms)
    {
      bar=split0(0,CHUMP,strlen(input)+1,initial_state);
      i=CHUMP;
      while(i+CHUMP<natoms)
	{
	  //	  if(i>2000) return 0;
	  if(time(0)!=j)
	    {
	      fprintf(stderr,"now chumping %i/%i\n",i,natoms);
	      j=time(0);
	    }
	  foo=split0(i,i+CHUMP,strlen(input)+1,initial_state);
	  bar=faccons(bar,foo);
	  i+=CHUMP;
	  //      puts("hi!");
	}
      foo=split0(i,natoms,strlen(input)+1,initial_state);
      bar=faccons(bar,foo);
    }
  else bar=split(0,natoms,strlen(input)+1,initial_state);
  if(kost(bar)>=strlen(input))
    printf(input);
  else
    printf(xx2str(bar));
#endif
  //  prxx(foo);
  //  for(i=0;i<natoms;i++) prxx(godown(i,initial_state));
  /*  best_length=length;
  temp_buf[j]=0;
  puts(temp_buf);
  printf("%i\n",search(0,natoms,0,initial_state,0));
  puts(temp_buf);
  printf("%i\n",strlen(temp_buf));
  puts(input);*/
  return 0;
}
#endif

int main(int argc, char *argv[])
{
  int i;
  assert(getenv("TLIMIT"));
  if(argc==3 && !strcmp(argv[1],"felch"))
    {
      i=atoi(argv[2]);
      sodomite(i);
    }
  else
    wrapper(atoi(getenv("TLIMIT"))/2.0);
  return 0;
}
